CREATE TYPE "device_type" AS ENUM (
  'pv',
  'LED'
);

CREATE TYPE "shape" AS ENUM (
  'circle',
  'rectangle'
);

CREATE TYPE "source" AS ENUM (
  'voltage',
  'current'
);

CREATE TYPE "user_type" AS ENUM (
  'superuser',
  'superreader',
  'user',
  'visitor'
);

CREATE TYPE "tco_type" AS ENUM (
  'ITO',
  'FTO',
  'AZO'
);

CREATE TABLE "tbl_users" (
  "id" INTEGER GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "name" text,
  "created_at" timestampz,
  "type" user_type
);

CREATE TABLE "tbl_run" (
  "id" INTEGER GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "user_id" integer,
  "start_date" timestampz,
  "UUID" uuid,
  "name" text,
  "suns" real,
  "recipe" text,
  "duration" interval,
  "placeholder" integer
);

CREATE TABLE "tbl_substrates" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "substrate_type_id" integer,
  "label" text UNIQUE,
  "label_creation" timestamp
);

CREATE TABLE "tbl_substrate_types" (
  "id" INTEGER GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "mfg" text,
  "batch" text,
  "tco_pattern_name" text,
  "tco_type" tco_type,
  "sheet_resistance" real,
  "t550" real
);

CREATE TABLE "tbl_layouts" (
  "id" INTEGER GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "name" text,
  "version" text,
  "substrate_extents" box
);

CREATE TABLE "tbl_layout_devices" (
  "id" INTEGER GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "layout_id" integer,
  "number" integer,
  "light_circle" circle,
  "dark_circle" circle,
  "light_outline" path,
  "dark_outline" path
);

CREATE TABLE "tbl_devices" (
  "substrate_id" bigint,
  "layout_pixel_id" integer,
  "type" device_type
);

CREATE TABLE "tbl_setups" (
  "id" INTEGER GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "name" text,
  "site_id" omt,
  "experiments" jsonb
);

CREATE TABLE "tbl_sites" (
  "id" INTEGER GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "name" text
);

CREATE TABLE "tbl_measurement_slot" (
  "id" INTEGER GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "setup_id" integer,
  "designator" text,
  "offset" point
);

CREATE TABLE "tbl_iv_event" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "run_id" integer,
  "slot_id" integer,
  "layout_devices_id" integer,
  "n_points" integer,
  "duration" interval,
  "rate" real,
  "fixed" source,
  "metadata_placeholder" real
);

CREATE TABLE "tbl_ss_events" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "run_id" integer,
  "slot_id" integer,
  "layout_devices_id" integer,
  "n_points" integer,
  "duration" interval,
  "setpoint" real,
  "fixed" source,
  "metadata_placeholder" real
);

CREATE TABLE "tbl_mppt_event" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "run_id" integer,
  "slot_id" integer,
  "layout_devices_id" integer,
  "n_points" integer,
  "duration" interval,
  "algorithm_name" text,
  "algorithm_version" text,
  "algorithm_parameters" jsonb,
  "source" source,
  "metadata_placeholder" real
);

CREATE TABLE "tbl_smdat" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "voltage" real,
  "current" real,
  "hardware_timestamp" real,
  "status" int
);

CREATE TABLE "tbl_smus" (
  "id" INTEGER GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
  "name" text,
  "idn" text
);

CREATE TABLE "tbl_slot_substrate" (
  "substrate_id" bigint,
  "run_id" integer,
  "slot_id" integer
);

CREATE TABLE "tbl_slot_tool" (
  "set_hash_id" integer,
  "slot_id" integer,
  "smu_id" integer
);

CREATE TABLE "tbl_slot_set_hashes" (
  "set_hash_id" integer,
  "hash" int,
  "slot_id" integer,
  "smu_id" integer
);

COMMENT ON TABLE "tbl_users" IS 'One row per user';

COMMENT ON TABLE "tbl_run" IS 'One row per time Start button pressed on setup';

COMMENT ON COLUMN "tbl_run"."placeholder" IS 'TODO: many cols to add here';

COMMENT ON TABLE "tbl_substrates" IS 'One row per substrate labeled';

COMMENT ON TABLE "tbl_substrate_types" IS 'One per substrate type';

COMMENT ON COLUMN "tbl_substrate_types"."sheet_resistance" IS 'ohm/sq';

COMMENT ON COLUMN "tbl_substrate_types"."t550" IS 'percent transmission at 550nm';

COMMENT ON TABLE "tbl_layouts" IS 'One row per unique layout design';

COMMENT ON TABLE "tbl_layout_devices" IS 'One row per pixel on a layout design';

COMMENT ON COLUMN "tbl_layout_devices"."number" IS 'pixel number';

COMMENT ON COLUMN "tbl_layout_devices"."light_circle" IS 'dims are mm, for circular illuminated area';

COMMENT ON COLUMN "tbl_layout_devices"."dark_circle" IS 'dims are mm, for circular dark area';

COMMENT ON COLUMN "tbl_layout_devices"."light_outline" IS 'dims are mm, illuminated outline area';

COMMENT ON COLUMN "tbl_layout_devices"."dark_outline" IS 'dims are mm, dark outline area';

COMMENT ON TABLE "tbl_devices" IS 'One row per individual device fabricated, that is generally 6 per substrate';

COMMENT ON TABLE "tbl_setups" IS 'One row per measurement setup';

COMMENT ON TABLE "tbl_sites" IS 'One row per site setup';

COMMENT ON TABLE "tbl_measurement_slot" IS 'One per measurement slot in a setup';

COMMENT ON TABLE "tbl_iv_event" IS 'One row per JV scan executed';

COMMENT ON COLUMN "tbl_iv_event"."fixed" IS 'TODO: check if this is redundant, redundant with status byte';

COMMENT ON COLUMN "tbl_iv_event"."metadata_placeholder" IS 'TODO: many cols to add here';

COMMENT ON TABLE "tbl_ss_events" IS 'One row per steady-state dwell executed';

COMMENT ON COLUMN "tbl_ss_events"."fixed" IS 'TODO: check if this is redundant, redundant with status byte';

COMMENT ON COLUMN "tbl_ss_events"."metadata_placeholder" IS 'TODO: many cols to add here';

COMMENT ON TABLE "tbl_mppt_event" IS 'One row per mppt interval executed';

COMMENT ON COLUMN "tbl_mppt_event"."source" IS 'TODO: check if this is redundant, redundant with status byte';

COMMENT ON COLUMN "tbl_mppt_event"."metadata_placeholder" IS 'TODO: many cols to add here';

COMMENT ON TABLE "tbl_smdat" IS 'holds data points collected by any smu';

COMMENT ON TABLE "tbl_smus" IS 'One row per smu';

COMMENT ON TABLE "tbl_slot_substrate" IS 'N rows per run where N is the number of slots loaded in that run';

COMMENT ON TABLE "tbl_slot_tool" IS 'describes how the data tools are wired to slots. if/when the wiring changes, the revision number is bumped';

COMMENT ON TABLE "tbl_slot_set_hashes" IS 'describes how the data tools are wired to slots. if/when the wiring changes, the revision number is bumped';

ALTER TABLE "tbl_run" ADD FOREIGN KEY ("user_id") REFERENCES "tbl_users" ("id");

ALTER TABLE "tbl_substrates" ADD FOREIGN KEY ("substrate_type_id") REFERENCES "tbl_substrate_types" ("id");

ALTER TABLE "tbl_layout_devices" ADD FOREIGN KEY ("layout_id") REFERENCES "tbl_layouts" ("id");

ALTER TABLE "tbl_devices" ADD FOREIGN KEY ("substrate_id") REFERENCES "tbl_substrates" ("id");

ALTER TABLE "tbl_devices" ADD FOREIGN KEY ("layout_pixel_id") REFERENCES "tbl_layout_devices" ("id");

ALTER TABLE "tbl_setups" ADD FOREIGN KEY ("site_id") REFERENCES "tbl_sites" ("id");

ALTER TABLE "tbl_measurement_slot" ADD FOREIGN KEY ("setup_id") REFERENCES "tbl_setups" ("id");

ALTER TABLE "tbl_iv_event" ADD FOREIGN KEY ("run_id") REFERENCES "tbl_run" ("id");

ALTER TABLE "tbl_iv_event" ADD FOREIGN KEY ("slot_id") REFERENCES "tbl_measurement_slot" ("id");

ALTER TABLE "tbl_iv_event" ADD FOREIGN KEY ("layout_devices_id") REFERENCES "tbl_layout_devices" ("id");

ALTER TABLE "tbl_ss_events" ADD FOREIGN KEY ("run_id") REFERENCES "tbl_run" ("id");

ALTER TABLE "tbl_ss_events" ADD FOREIGN KEY ("slot_id") REFERENCES "tbl_measurement_slot" ("id");

ALTER TABLE "tbl_ss_events" ADD FOREIGN KEY ("layout_devices_id") REFERENCES "tbl_layout_devices" ("id");

ALTER TABLE "tbl_mppt_event" ADD FOREIGN KEY ("run_id") REFERENCES "tbl_run" ("id");

ALTER TABLE "tbl_mppt_event" ADD FOREIGN KEY ("slot_id") REFERENCES "tbl_measurement_slot" ("id");

ALTER TABLE "tbl_mppt_event" ADD FOREIGN KEY ("layout_devices_id") REFERENCES "tbl_layout_devices" ("id");

ALTER TABLE "tbl_slot_substrate" ADD FOREIGN KEY ("substrate_id") REFERENCES "tbl_substrates" ("id");

ALTER TABLE "tbl_slot_substrate" ADD FOREIGN KEY ("run_id") REFERENCES "tbl_run" ("id");

ALTER TABLE "tbl_slot_substrate" ADD FOREIGN KEY ("slot_id") REFERENCES "tbl_measurement_slot" ("id");

ALTER TABLE "tbl_slot_tool" ADD FOREIGN KEY ("slot_id") REFERENCES "tbl_measurement_slot" ("id");

ALTER TABLE "tbl_slot_tool" ADD FOREIGN KEY ("smu_id") REFERENCES "tbl_smus" ("id");

ALTER TABLE "tbl_slot_set_hashes" ADD FOREIGN KEY ("slot_id") REFERENCES "tbl_measurement_slot" ("id");

ALTER TABLE "tbl_slot_set_hashes" ADD FOREIGN KEY ("smu_id") REFERENCES "tbl_smus" ("id");
